//+------------------------------------------------------------------+
//|   Instant_Trendline.mq4
//+------------------------------------------------------------------+
#property indicator_chart_window
#include <stdlib.mqh>
#property indicator_buffers 3

extern double alpha = 0.09;
extern int PriceType = PRICE_CLOSE;
extern color ITColor = Green;
extern color TriggerColor = Red;

double IT[];
double Trigger[];
double Price[];

int init()
{
   IndicatorBuffers(3);
   
   SetIndexStyle(0,DRAW_LINE,0,1,ITColor);
   SetIndexBuffer(0,IT);

   SetIndexStyle(1,DRAW_LINE,0,1,TriggerColor);
   SetIndexBuffer(1,Trigger);

   SetIndexStyle(2,DRAW_NONE);
   SetIndexBuffer(2,Price);

   return(0);
}

int deinit()
{
   return(0);
}

int start()
{
   int counted_bars=IndicatorCounted();
   if(counted_bars<0) return(-1); //---- check for possible errors
   if(counted_bars>0) counted_bars--; //---- last counted bar will be recounted
   int limit = Bars-counted_bars;
   
   for (int i=limit;i>=0;i--)
   {
      Price[i] = iMA(NULL,0,1,0,MODE_SMA,PRICE_CLOSE,i);

      IT[i] = (alpha - alpha * alpha / 4.0) * Price[i]
                  + 0.5 * alpha * alpha * Price[i+1] 
                  - (alpha - 0.75 * alpha * alpha) * Price[i+2]
                  + 2.0 * (1.0 - alpha) * IT[i+1]
                  - (1.0 - alpha) * (1.0 - alpha) * IT[i+2];

      Trigger[i] = 2.0 * IT[i] - IT[i+2];
   }
}

